/*

	Historical Spawn Dates
	by Gedemon (2013-2017)

*/

-------------------------------------------------------------------------------
-- Fill table with Historical Spawn Dates for all Civilizations (Old World Start table)
-------------------------------------------------------------------------------

INSERT OR REPLACE INTO HistoricalSpawnDates
(	Civilization,				StartYear) 
VALUES
-- Major Civilizations
(	'CIVILIZATION_AMERICA',			 1600	),
(	'CIVILIZATION_ARABIA',			 -3200	),
(	'CIVILIZATION_ARMAGH',			 -300	),
(	'CIVILIZATION_AUSTRALIA',		 1600	),
(	'CIVILIZATION_AZTEC',			 -1200	),
(	'CIVILIZATION_BRAZIL',			 1600	),
(	'CIVILIZATION_BYZANTIUM',		400		),
(	'CIVILIZATION_CANADA',		 	1600	),
(	'CIVILIZATION_CHINA',			-2400	),
(	'CIVILIZATION_CREE',			-800	),
(	'CIVILIZATION_ENGLAND',			 500	),
(	'CIVILIZATION_EGYPT',			-3200	),
(	'CIVILIZATION_ETHIOPIA',		-2400	),
(	'CIVILIZATION_FRANCE',			450 	),
(	'CIVILIZATION_GAUL',			 -1600	),
(	'CIVILIZATION_GEORGIA',			-2000	),
(	'CIVILIZATION_GERMANY',			450		),
(	'CIVILIZATION_GRAN_COLOMBIA',	1600	),
(	'CIVILIZATION_GREECE',			-1600	),
(	'CIVILIZATION_HUNGARY',			   600	),
(	'CIVILIZATION_INCA',			  -2000	),
(	'CIVILIZATION_INDIA',			-2500	),
(	'CIVILIZATION_INDONESIA',		 400	),
(	'CIVILIZATION_JAPAN',			 500	),
(	'CIVILIZATION_KHMER',			-800	),
(	'CIVILIZATION_KONGO',			 -1500	),
(	'CIVILIZATION_KOREA',			  -500	),
(	'CIVILIZATION_MAPUCHE',			-800	),
(	'CIVILIZATION_MAYA',			-1600	),
(	'CIVILIZATION_MACEDON',			  -1200	),
(	'CIVILIZATION_MALI',			  -1000	),
(	'CIVILIZATION_MAORI',		 	-1200	),
(	'CIVILIZATION_MONGOLIA',		-1200	),
(	'CIVILIZATION_NETHERLANDS',		 800	),
(	'CIVILIZATION_NORWAY',			 -1200	),
(	'CIVILIZATION_NUBIA',			-2400	),
(	'CIVILIZATION_OTTOMAN',			 600	),
(	'CIVILIZATION_PERSIA',			-3400	),
(	'CIVILIZATION_PHOENICIA',		  -1600	),
(	'CIVILIZATION_POLAND',			  500	),
(	'CIVILIZATION_ROME',			 -1200	),
(	'CIVILIZATION_RUSSIA',			  600	),
(	'CIVILIZATION_SCOTLAND',		500	),
(	'CIVILIZATION_SCYTHIA',			 -800	),
(	'CIVILIZATION_SPAIN',			450	),
(	'CIVILIZATION_SUMERIA',			-4100	),
(	'CIVILIZATION_SWEDEN',			  -600	),
(	'CIVILIZATION_ZULU',			 -1200	),
-- Minor Civilizations
(	'CIVILIZATION_AKKAD',			 -3960	),
(	'CIVILIZATION_AMSTERDAM',		 1581	),
(	'CIVILIZATION_ANTANANARIVO',	 1625	),
(	'CIVILIZATION_ANTIOCH',			  -2400	),
(	'CIVILIZATION_AUCKLAND',		1700	),
(	'CIVILIZATION_BABYLON',			 -3960	),
(	'CIVILIZATION_BOLOGNA',		 -1200	),
(	'CIVILIZATION_BRUSSELS',		  -200	),
(	'CIVILIZATION_BUENOS_AIRES',	 1500	),
(	'CIVILIZATION_CAGUANA',			 600	),
(	'CIVILIZATION_CAHOKIA',			 400	),
(	'CIVILIZATION_CARDIFF',		 	-600	),
(	'CIVILIZATION_CARTHAGE',		 -2000	),
(	'CIVILIZATION_FEZ',		  		-600	),
(	'CIVILIZATION_GENEVA',			 -121	),
(	'CIVILIZATION_GRANADA',			 -600	),
(	'CIVILIZATION_HATTUSA',			-2000	),
(	'CIVILIZATION_HONG_KONG',		 -1000	),
(	'CIVILIZATION_JAKARTA',			  400	),
(	'CIVILIZATION_JERUSALEM',		-3960	),
(	'CIVILIZATION_KABUL',			 -3400	),
(	'CIVILIZATION_KANDY',			 -1000	),
(	'CIVILIZATION_KUMASI',			 -1000	),
(	'CIVILIZATION_LAHORE',			-2500	),
(	'CIVILIZATION_LA_VENTA',		-2400	),
(	'CIVILIZATION_LISBON',			-800	),
(	'CIVILIZATION_MEXICO_CITY',		 1200	),
(	'CIVILIZATION_MOHENJO_DARO',	-3960	),
(	'CIVILIZATION_MUSCAT',			-3960	),
(	'CIVILIZATION_NAN_MADOL',		 1180	),
(	'CIVILIZATION_NAZCA',		 	-3000	),
(	'CIVILIZATION_NGAZARGAMU',		 -2400	),
(	'CIVILIZATION_PALENQUE',		-1600	),
(	'CIVILIZATION_PRESLAV',			  -1600	),
(	'CIVILIZATION_RAPA_NUI',			600	),
(	'CIVILIZATION_SEOUL',			  -1000	),
(	'CIVILIZATION_SINGAPORE',		  200	),
(	'CIVILIZATION_STOCKHOLM',		 -600	),
(	'CIVILIZATION_TARUGA',		 	-1200	),
(	'CIVILIZATION_TORONTO',			 1600	),
(	'CIVILIZATION_VALLETTA',		 -600	),
(	'CIVILIZATION_VATICAN_CITY',	 400	),
(	'CIVILIZATION_VILNIUS',			 -800	),
(	'CIVILIZATION_YEREVAN',			-2400	),
(	'CIVILIZATION_ZANZIBAR',		 -600	),
(	'END_OF_INSERT',				NULL	);	
-- Remove "END_OF_INSERT" entry 
DELETE from HistoricalSpawnDates WHERE Civilization ='END_OF_INSERT';

-------------------------------------------------------------------------------
-- Fill table with Historical Spawn Dates for New World and Isolated Civs only
-------------------------------------------------------------------------------

INSERT OR REPLACE INTO HistoricalSpawnDates_NewWorld
(	Civilization,				StartYear) 
VALUES
-- Major Civilizations
(	'CIVILIZATION_AMERICA',				1600),
(	'CIVILIZATION_ARABIA',				-4100),
(	'CIVILIZATION_ARMAGH',				-4100),
(	'CIVILIZATION_AUSTRALIA',			1600),
(	'CIVILIZATION_AZTEC',				-1200),
(	'CIVILIZATION_BRAZIL',				1600),
(	'CIVILIZATION_BYZANTIUM',			 -4100),
(	'CIVILIZATION_CANADA',		 	 	1600),
(	'CIVILIZATION_CHINA',				-4100),
(	'CIVILIZATION_CREE',				-800),
(	'CIVILIZATION_ENGLAND',				-4100),
(	'CIVILIZATION_EGYPT',				-4100),
(	'CIVILIZATION_ETHIOPIA',			-2400),
(	'CIVILIZATION_FRANCE',				-4100),
(	'CIVILIZATION_GAUL',				-4100),
(	'CIVILIZATION_GEORGIA',				-4100),
(	'CIVILIZATION_GERMANY',				-4100),
(	'CIVILIZATION_GRAN_COLOMBIA',		1600),
(	'CIVILIZATION_GREECE',				-4100),
(	'CIVILIZATION_HUNGARY',				-4100),
(	'CIVILIZATION_INCA',				-1200),
(	'CIVILIZATION_INDIA',				-4100),
(	'CIVILIZATION_INDONESIA',			-4100),
(	'CIVILIZATION_JAPAN',				-4100),
(	'CIVILIZATION_KHMER',				-4100),
(	'CIVILIZATION_KONGO',				-4100),
(	'CIVILIZATION_KOREA',				-4100),
(	'CIVILIZATION_MAPUCHE',				-800),
(	'CIVILIZATION_MACEDON',				-4100),
(	'CIVILIZATION_MALI',				-4100),
(	'CIVILIZATION_MAORI',		 		-1200),
(	'CIVILIZATION_MAYA',		 		-1600),
(	'CIVILIZATION_MONGOLIA',			-4100),
(	'CIVILIZATION_NETHERLANDS',			-4100),
(	'CIVILIZATION_NORWAY',				-4100),
(	'CIVILIZATION_NUBIA',				-4100),
(	'CIVILIZATION_OTTOMAN',				-4100),
(	'CIVILIZATION_PERSIA',				-4100),
(	'CIVILIZATION_PHOENICIA',			-4100),
(	'CIVILIZATION_POLAND',				-4100),
(	'CIVILIZATION_ROME',				-4100),
(	'CIVILIZATION_RUSSIA',				-4100),
(	'CIVILIZATION_SCOTLAND',			-4100),
(	'CIVILIZATION_SCYTHIA',				-4100),
(	'CIVILIZATION_SPAIN',				-4100),
(	'CIVILIZATION_SUMERIA',				-4100),
(	'CIVILIZATION_SWEDEN',				-4100),
(	'CIVILIZATION_ZULU',				-4100),
-- Minor Civilizations
(	'CIVILIZATION_AKKAD',				-3960),
(	'CIVILIZATION_AMSTERDAM',			-3960),
(	'CIVILIZATION_ANTANANARIVO',		600),
(	'CIVILIZATION_ANTIOCH',				-3960),
(	'CIVILIZATION_AUCKLAND',			1600),
(	'CIVILIZATION_BABYLON',				-3960),
(	'CIVILIZATION_BOLOGNA',		 		-3960),
(	'CIVILIZATION_BRUSSELS',			-3960),
(	'CIVILIZATION_BUENOS_AIRES',		-600),
(	'CIVILIZATION_CAGUANA',				-600),
(	'CIVILIZATION_CAHOKIA',				-600),
(	'CIVILIZATION_CARDIFF',		 		-3960),
(	'CIVILIZATION_FEZ',		  			-3960),
(	'CIVILIZATION_GENEVA',				-3960),
(	'CIVILIZATION_GRANADA',				-3960),
(	'CIVILIZATION_HATTUSA',				-3960),
(	'CIVILIZATION_HUNZA',				-3960),
(	'CIVILIZATION_HONG_KONG',			-3960),
(	'CIVILIZATION_JAKARTA',				-3960),
(	'CIVILIZATION_JERUSALEM',			-3960),
(	'CIVILIZATION_KABUL',				-3960),
(	'CIVILIZATION_KANDY',				-3960),
(	'CIVILIZATION_KUMASI',				-3960),
(	'CIVILIZATION_LAHORE',				-3960),
(	'CIVILIZATION_LA_VENTA',			-2600),
(	'CIVILIZATION_LHASA',				-3960),
(	'CIVILIZATION_LISBON',				-3960),
(	'CIVILIZATION_MEXICO_CITY',			-1200),
(	'CIVILIZATION_MOHENJO_DARO',		-3960),
(	'CIVILIZATION_MUSCAT',				-3960),
(	'CIVILIZATION_NAN_MADOL',			-1200),
(	'CIVILIZATION_NAZCA',		 		-2600),
(	'CIVILIZATION_NGAZARGAMU',			-3960),
(	'CIVILIZATION_PALENQUE',			-2000),
(	'CIVILIZATION_PRESLAV',				-3960),
(	'CIVILIZATION_RAPA_NUI',			600),
(	'CIVILIZATION_SEOUL',				-3960),
(	'CIVILIZATION_SINGAPORE',			-3960),
(	'CIVILIZATION_STOCKHOLM',			-3960),
(	'CIVILIZATION_TARUGA',				-3960),
(	'CIVILIZATION_TORONTO',				1600),
(	'CIVILIZATION_VALLETTA',			-3960),
(	'CIVILIZATION_VATICAN_CITY',		-3960),
(	'CIVILIZATION_VILNIUS',				-3960),
(	'CIVILIZATION_YEREVAN',				-3960),
(	'CIVILIZATION_ZANZIBAR',			-3960),
(	'END_OF_INSERT',				NULL	);	
-- Remove "END_OF_INSERT" entry 
DELETE from HistoricalSpawnDates_NewWorld WHERE Civilization ='END_OF_INSERT';

-------------------------------------------------------------------------------
-- Fill table with Historical Spawn Eras
-- 0 - Ancient Era
-- 1 - Classical Era
-- 2 - Medieval Era
-- 3 - Renaissance Era
-- 4 - Industrial Era
-- 5 - Modern Era
-- 6 - Atomic Era
-- 7 - Digital Era
-- 8 - Future Era
-------------------------------------------------------------------------------
INSERT OR REPLACE INTO HistoricalSpawnEras
(	Civilization,				Era) 
VALUES
-- Major Civilizations
(	'CIVILIZATION_AMERICA',				4 ),
(	'CIVILIZATION_ARABIA',				1 ),
(	'CIVILIZATION_AUSTRALIA',			4 ),
(	'CIVILIZATION_AZTEC',				1 ),
(	'CIVILIZATION_BRAZIL',				4 ),
(	'CIVILIZATION_BYZANTIUM',			2 ),
(	'CIVILIZATION_CANADA',		 	 	4 ),
(	'CIVILIZATION_CHINA',				0 ),
(	'CIVILIZATION_CREE',				2 ),
(	'CIVILIZATION_ENGLAND',				2 ),
(	'CIVILIZATION_EGYPT',				0 ),
(	'CIVILIZATION_ETHIOPIA',			1 ),
(	'CIVILIZATION_FRANCE',				2 ),
(	'CIVILIZATION_GAUL',				0 ),
(	'CIVILIZATION_GEORGIA',				1 ),
(	'CIVILIZATION_GERMANY',				2 ),
(	'CIVILIZATION_GRAN_COLOMBIA',		4 ),
(	'CIVILIZATION_GREECE',				1 ),
(	'CIVILIZATION_HUNGARY',				2 ),
(	'CIVILIZATION_INCA',				1 ),
(	'CIVILIZATION_INDIA',				0 ),
(	'CIVILIZATION_INDONESIA',			2 ),
(	'CIVILIZATION_JAPAN',				2 ),
(	'CIVILIZATION_KHMER',				2 ),
(	'CIVILIZATION_KONGO',				2 ),
(	'CIVILIZATION_KOREA',				1 ),
(	'CIVILIZATION_MAPUCHE',				2 ),
(	'CIVILIZATION_MACEDON',				1 ),
(	'CIVILIZATION_MALI',				2 ),
(	'CIVILIZATION_MAORI',		 		1 ),
(	'CIVILIZATION_MAYA',		 		1 ),
(	'CIVILIZATION_MONGOLIA',			1 ),
(	'CIVILIZATION_NETHERLANDS',			2 ),
(	'CIVILIZATION_NORWAY',				1 ),
(	'CIVILIZATION_NUBIA',				1 ),
(	'CIVILIZATION_OTTOMAN',				3 ),
(	'CIVILIZATION_PERSIA',				0 ),
(	'CIVILIZATION_PHOENICIA',			1 ),
(	'CIVILIZATION_POLAND',				2 ),
(	'CIVILIZATION_ROME',				1 ),
(	'CIVILIZATION_RUSSIA',				2 ),
(	'CIVILIZATION_SCOTLAND',			2 ),
(	'CIVILIZATION_SCYTHIA',				1 ),
(	'CIVILIZATION_SPAIN',				2 ),
(	'CIVILIZATION_SUMERIA',				0 ),
(	'CIVILIZATION_SWEDEN',				2 ),
(	'CIVILIZATION_ZULU',				3 ),
-- Minor Civilizations
(	'CIVILIZATION_AKKAD',				0 ),
(	'CIVILIZATION_AMSTERDAM',			2 ),
(	'CIVILIZATION_ANTANANARIVO',		3 ),
(	'CIVILIZATION_ANTIOCH',				1 ),
(	'CIVILIZATION_ARMAGH',				2 ),
(	'CIVILIZATION_AUCKLAND',			4 ),
(	'CIVILIZATION_BABYLON',				0 ),
(	'CIVILIZATION_BOLOGNA',		 		2 ),
(	'CIVILIZATION_BRUSSELS',			2 ),
(	'CIVILIZATION_BUENOS_AIRES',		4 ),
(	'CIVILIZATION_CAGUANA',				2 ),
(	'CIVILIZATION_CAHOKIA',				2 ),
(	'CIVILIZATION_CARDIFF',		 		1 ),
(	'CIVILIZATION_FEZ',		  			2 ),
(	'CIVILIZATION_GENEVA',				1 ),
(	'CIVILIZATION_GRANADA',				2 ),
(	'CIVILIZATION_HATTUSA',				0 ),
(	'CIVILIZATION_HUNZA',				1 ),
(	'CIVILIZATION_HONG_KONG',			2 ),
(	'CIVILIZATION_JAKARTA',				2 ),
(	'CIVILIZATION_JERUSALEM',			0 ),
(	'CIVILIZATION_KABUL',				0 ),
(	'CIVILIZATION_KANDY',				2 ),
(	'CIVILIZATION_KUMASI',				2 ),
(	'CIVILIZATION_LAHORE',				0 ),
(	'CIVILIZATION_LA_VENTA',			1 ),
(	'CIVILIZATION_LHASA',				1 ),
(	'CIVILIZATION_LISBON',				2 ),
(	'CIVILIZATION_MEXICO_CITY',			1 ),
(	'CIVILIZATION_MOHENJO_DARO',		0 ),
(	'CIVILIZATION_MUSCAT',				0 ),
(	'CIVILIZATION_NAN_MADOL',			1 ),
(	'CIVILIZATION_NAZCA',		 		0 ),
(	'CIVILIZATION_NGAZARGAMU',			2 ),
(	'CIVILIZATION_PALENQUE',			1 ),
(	'CIVILIZATION_PRESLAV',				1 ),
(	'CIVILIZATION_RAPA_NUI',			2 ),
(	'CIVILIZATION_SEOUL',				1 ),
(	'CIVILIZATION_SINGAPORE',			2 ),
(	'CIVILIZATION_STOCKHOLM',			1 ),
(	'CIVILIZATION_TARUGA',				1 ),
(	'CIVILIZATION_TORONTO',				4 ),
(	'CIVILIZATION_VALLETTA',			1 ),
(	'CIVILIZATION_VATICAN_CITY',		1 ),
(	'CIVILIZATION_VILNIUS',				2 ),
(	'CIVILIZATION_YEREVAN',				0 ),
(	'CIVILIZATION_ZANZIBAR',			2 ),
(	'END_OF_INSERT',				NULL	);	
-- Remove "END_OF_INSERT" entry 
DELETE from HistoricalSpawnEras WHERE Civilization ='END_OF_INSERT';

--End